/*
 * $Id: loadw.c 729 2005-05-14 19:41:43 +0200 (Sat, 14 May 2005) mhe $
 *
 * Read Weightmatrix
 *
 */
 
 #include <stdlib.h>
 #include <stdio.h>
 
 #include "lstm.h"
 #include "loadw.h"
 
 void load_weights(char *filename) {
    FILE *fp;
    int res,i,j;
    int dummy;
    
    printf("loading weights: %s\n", filename); 

    if ((fp=fopen(filename,"r")) == NULL) {
        fprintf(stderr, "can't open %s\n", filename);
        exit(1);
    }
    
    /* */
    res = fscanf(fp, "anz:%d\n", &numb_seq);
    if (!res || res == EOF) {
      fprintf(stderr,"Error on reading weightfile, no number of sequences provided\n");
      exit(1);
    }

    
    for (i = 0; i< ges_mod; i++) {
        for (j = 0; j < ges_mod - 1; j++) {
            res = fscanf(fp, "(%d,%d): %lf ", &dummy, &dummy, &W[i][j]);
            if (!res || res == EOF) {
                fprintf(stderr,"Error on reading weightfile, weight not found: Line %d Token %d\n", i, j + 1);
                exit(1);
            }
        }
        res = fscanf(fp, "(%d,%d): %lf\n", &dummy, &dummy, &W[i][j]);
        if (!res || res == EOF) {
            fprintf(stderr,"Error on reading weightfile, weight not found: Line %d Token %d\n", i, j + 1);
            exit(1);
        }
    }
    
    fclose(fp);
 }
 
