  /* memory management 
  * 
  * 
  * $Id: mmu.c 729 2005-05-14 19:41:43 +0200 (Sat, 14 May 2005) mhe $ 
  */

#include <stdlib.h>
#include <stdio.h>
#include "lstm.h"
#include "mmu.h"

/* allocates a char array */
char *allocCharArray (char *data, int size) {
  return (char*)malloc(sizeof(char) * size);
}

/* allocates a 2 dim char array */
char **alloc2DimCharArray (char **data, int sizeDim0, int sizeDim1) {
  int i;
  data = (char**)malloc(sizeof(char*)*sizeDim0);
  if (data) {
    for (i = 0; i < sizeDim0; i++) {
        data[i] = (char*)malloc(sizeof(char)*sizeDim1);
    }
  }
  else {
    printf("Memory Allocation Error\n");
    exit(0);
  }
  return data;
}



/* allocates an integer array */
int *allocIntArray (int *data, int size) {
  return (int*)malloc(sizeof(int) * size);
}

/* allocates a 2 dim integer array */
int **alloc2DimIntArray (int **data, int sizeDim0, int sizeDim1) {
  int i;
  data = (int**)malloc(sizeof(int*)*sizeDim0);
  if (data) {
    for (i = 0; i < sizeDim0; i++) {
        data[i] = (int*)malloc(sizeof(int) * sizeDim1);
    }
  }
  else {
    printf("Memory Allocation Error\n");
    exit(0);
  }
  return data;
}

/* allocates a double array */
double *allocDoubleArray (double *data, int size) {
  return (double*)malloc(sizeof(double) * size);
}

/* allocates a 2 dim double array */
double **alloc2DimDoubleArray (double **data, int sizeDim0, int sizeDim1) {
  int i;
  data = (double**)malloc(sizeof(double*)*sizeDim0);
  if (data) {
    for (i = 0; i < sizeDim0; i++) {
        data[i] = (double*)malloc(sizeof(double)*sizeDim1);
    }
  }
  else {
    printf("Memory Allocation Error\n");
    exit(0);
  }
  return data;
}

/* allocates a 3 dim double array */
double ***alloc3DimDoubleArray (double ***data, int sizeDim0, int sizeDim1, int sizeDim2) {
  int i,j;
  data = (double***)malloc(sizeof(double**)*sizeDim0);
  if (data) {
    for (i = 0; i < sizeDim0; i++) {
        data[i] = (double**)malloc(sizeof(double*)*sizeDim1);
        if (data[i]) {
            for (j = 0; j < sizeDim1; j++) {
                data[i][j] = (double*)malloc(sizeof(double)*sizeDim2);
            }
        }
        else {
            printf("Memory Allocation Error\n");
            exit(0);
        }
    }
  }
  else {
    printf("Memory Allocation Error\n");
    exit(0);
  }
  return data;
}



